/* accelerator.c generated by valac 0.56.13, the Vala compiler
 * generated from accelerator.vala, do not modify */

/*
 * based on keyboard-shortcuts.c from gnome-control-center
 *
 * Copyright (c) 2013 gnome-pomodoro contributors
 *               2010 Intel, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *          Thomas Wood <thomas.wood@intel.com>
 *          Rodrigo Moya <rodrigo@gnome.org>
 */
/* TODO:
 * Handle integration with window manager
 *  - suppress any keybings from being triggered
 *  - if keybinding is taken, notify about it
 *
 * For now gnome-shell extension is responsible for setting it.
 */

#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "gnome-pomodoro.h"

#define POMODORO_TYPE_ACCELERATOR_ERROR (pomodoro_accelerator_error_get_type ())

#define POMODORO_TYPE_ACCELERATOR (pomodoro_accelerator_get_type ())
#define POMODORO_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_ACCELERATOR, PomodoroAccelerator))
#define POMODORO_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_ACCELERATOR, PomodoroAcceleratorClass))
#define POMODORO_IS_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_ACCELERATOR))
#define POMODORO_IS_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_ACCELERATOR))
#define POMODORO_ACCELERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_ACCELERATOR, PomodoroAcceleratorClass))

typedef struct _PomodoroAccelerator PomodoroAccelerator;
typedef struct _PomodoroAcceleratorClass PomodoroAcceleratorClass;
typedef struct _PomodoroAcceleratorPrivate PomodoroAcceleratorPrivate;
enum  {
	POMODORO_ACCELERATOR_0_PROPERTY,
	POMODORO_ACCELERATOR_NAME_PROPERTY,
	POMODORO_ACCELERATOR_DISPLAY_NAME_PROPERTY,
	POMODORO_ACCELERATOR_NUM_PROPERTIES
};
static GParamSpec* pomodoro_accelerator_properties[POMODORO_ACCELERATOR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
enum  {
	POMODORO_ACCELERATOR_CHANGED_SIGNAL,
	POMODORO_ACCELERATOR_NUM_SIGNALS
};
static guint pomodoro_accelerator_signals[POMODORO_ACCELERATOR_NUM_SIGNALS] = {0};

typedef enum  {
	POMODORO_ACCELERATOR_ERROR_INVALID,
	POMODORO_ACCELERATOR_ERROR_FORBIDDEN,
	POMODORO_ACCELERATOR_ERROR_TYPING_COLLISION
} PomodoroAcceleratorError;
#define POMODORO_ACCELERATOR_ERROR pomodoro_accelerator_error_quark ()

struct _PomodoroAccelerator {
	GObject parent_instance;
	PomodoroAcceleratorPrivate * priv;
};

struct _PomodoroAcceleratorClass {
	GObjectClass parent_class;
	void (*changed) (PomodoroAccelerator* self);
};

struct _PomodoroAcceleratorPrivate {
	guint _key;
	GdkModifierType _modifiers;
};

static gint PomodoroAccelerator_private_offset;
static gpointer pomodoro_accelerator_parent_class = NULL;

VALA_EXTERN GQuark pomodoro_accelerator_error_quark (void);
VALA_EXTERN GType pomodoro_accelerator_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType pomodoro_accelerator_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PomodoroAccelerator* pomodoro_accelerator_new_from_name (const gchar* name);
VALA_EXTERN PomodoroAccelerator* pomodoro_accelerator_construct_from_name (GType object_type,
                                                               const gchar* name);
VALA_EXTERN void pomodoro_accelerator_set_name (PomodoroAccelerator* self,
                                    const gchar* value);
static void pomodoro_accelerator_parse (const gchar* name,
                                 guint* keyval,
                                 GdkModifierType* modifiers);
VALA_EXTERN void pomodoro_accelerator_unset (PomodoroAccelerator* self);
static void pomodoro_accelerator_set_key (PomodoroAccelerator* self,
                                   guint value);
static void pomodoro_accelerator_set_modifiers (PomodoroAccelerator* self,
                                         GdkModifierType value);
static void pomodoro_accelerator_normalize (guint* keyval,
                                     GdkModifierType* modifiers);
VALA_EXTERN void pomodoro_accelerator_set_keyval (PomodoroAccelerator* self,
                                      guint keyval,
                                      GdkModifierType modifiers);
static guint pomodoro_accelerator_get_key (PomodoroAccelerator* self);
static GdkModifierType pomodoro_accelerator_get_modifiers (PomodoroAccelerator* self);
VALA_EXTERN void pomodoro_accelerator_validate (PomodoroAccelerator* self,
                                    GError** error);
static gchar** pomodoro_accelerator_get_keys_internal (PomodoroAccelerator* self,
                                                gboolean escape,
                                                gint* result_length1);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN gchar** pomodoro_accelerator_get_keys (PomodoroAccelerator* self,
                                       gint* result_length1);
VALA_EXTERN PomodoroAccelerator* pomodoro_accelerator_new (void);
VALA_EXTERN PomodoroAccelerator* pomodoro_accelerator_construct (GType object_type);
VALA_EXTERN gchar* pomodoro_accelerator_get_name (PomodoroAccelerator* self);
VALA_EXTERN gchar* pomodoro_accelerator_get_display_name (PomodoroAccelerator* self);
static void pomodoro_accelerator_real_changed (PomodoroAccelerator* self);
static void pomodoro_accelerator_finalize (GObject * obj);
static GType pomodoro_accelerator_get_type_once (void);
static void _vala_pomodoro_accelerator_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_pomodoro_accelerator_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

GQuark
pomodoro_accelerator_error_quark (void)
{
	return g_quark_from_static_string ("pomodoro-accelerator-error-quark");
}

static GType
pomodoro_accelerator_error_get_type_once (void)
{
	static const GEnumValue values[] = {{POMODORO_ACCELERATOR_ERROR_INVALID, "POMODORO_ACCELERATOR_ERROR_INVALID", "invalid"}, {POMODORO_ACCELERATOR_ERROR_FORBIDDEN, "POMODORO_ACCELERATOR_ERROR_FORBIDDEN", "forbidden"}, {POMODORO_ACCELERATOR_ERROR_TYPING_COLLISION, "POMODORO_ACCELERATOR_ERROR_TYPING_COLLISION", "typing-collision"}, {0, NULL, NULL}};
	GType pomodoro_accelerator_error_type_id;
	pomodoro_accelerator_error_type_id = g_enum_register_static ("PomodoroAcceleratorError", values);
	return pomodoro_accelerator_error_type_id;
}

GType
pomodoro_accelerator_error_get_type (void)
{
	static volatile gsize pomodoro_accelerator_error_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_accelerator_error_type_id__once)) {
		GType pomodoro_accelerator_error_type_id;
		pomodoro_accelerator_error_type_id = pomodoro_accelerator_error_get_type_once ();
		g_once_init_leave (&pomodoro_accelerator_error_type_id__once, pomodoro_accelerator_error_type_id);
	}
	return pomodoro_accelerator_error_type_id__once;
}

static inline gpointer
pomodoro_accelerator_get_instance_private (PomodoroAccelerator* self)
{
	return G_STRUCT_MEMBER_P (self, PomodoroAccelerator_private_offset);
}

PomodoroAccelerator*
pomodoro_accelerator_construct_from_name (GType object_type,
                                          const gchar* name)
{
	PomodoroAccelerator * self = NULL;
#line 90 "../src/accelerator.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 90 "../src/accelerator.vala"
	self = (PomodoroAccelerator*) g_object_new (object_type, NULL);
#line 92 "../src/accelerator.vala"
	pomodoro_accelerator_set_name (self, name);
#line 90 "../src/accelerator.vala"
	return self;
#line 219 "accelerator.c"
}

PomodoroAccelerator*
pomodoro_accelerator_new_from_name (const gchar* name)
{
#line 90 "../src/accelerator.vala"
	return pomodoro_accelerator_construct_from_name (POMODORO_TYPE_ACCELERATOR, name);
#line 227 "accelerator.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 244 "accelerator.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1489 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1489 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1489 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1490 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1491 "glib-2.0.vapi"
		start = string_length + start;
#line 271 "accelerator.c"
	}
#line 1493 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		end = string_length + end;
#line 277 "accelerator.c"
	}
#line 1496 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 283 "accelerator.c"
	} else {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 287 "accelerator.c"
	}
#line 1496 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1497 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 295 "accelerator.c"
	} else {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 299 "accelerator.c"
	}
#line 1497 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1499 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1499 "glib-2.0.vapi"
	result = _tmp4_;
#line 1499 "glib-2.0.vapi"
	return result;
#line 311 "accelerator.c"
}

static void
pomodoro_accelerator_parse (const gchar* name,
                            guint* keyval,
                            GdkModifierType* modifiers)
{
	guint _vala_keyval = 0U;
	GdkModifierType _vala_modifiers = 0U;
	gint pos = 0;
	gint start = 0;
	gchar chr = '\0';
	gboolean is_modifier = FALSE;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp10_;
	gchar* _tmp11_;
#line 99 "../src/accelerator.vala"
	pos = 0;
#line 100 "../src/accelerator.vala"
	start = 0;
#line 101 "../src/accelerator.vala"
	chr = '\0';
#line 102 "../src/accelerator.vala"
	is_modifier = FALSE;
#line 104 "../src/accelerator.vala"
	_vala_keyval = (guint) 0;
#line 105 "../src/accelerator.vala"
	_vala_modifiers = 0;
#line 107 "../src/accelerator.vala"
	if (name == NULL) {
#line 107 "../src/accelerator.vala"
		_tmp0_ = TRUE;
#line 344 "accelerator.c"
	} else {
#line 107 "../src/accelerator.vala"
		_tmp0_ = g_strcmp0 (name, "") == 0;
#line 348 "accelerator.c"
	}
#line 107 "../src/accelerator.vala"
	if (_tmp0_) {
#line 108 "../src/accelerator.vala"
		if (keyval) {
#line 108 "../src/accelerator.vala"
			*keyval = _vala_keyval;
#line 356 "accelerator.c"
		}
#line 108 "../src/accelerator.vala"
		if (modifiers) {
#line 108 "../src/accelerator.vala"
			*modifiers = _vala_modifiers;
#line 362 "accelerator.c"
		}
#line 108 "../src/accelerator.vala"
		return;
#line 366 "accelerator.c"
	}
#line 111 "../src/accelerator.vala"
	while (TRUE) {
#line 370 "accelerator.c"
		gint _tmp9_;
#line 111 "../src/accelerator.vala"
		chr = string_get (name, (glong) pos);
#line 111 "../src/accelerator.vala"
		if (!(chr != '\0')) {
#line 111 "../src/accelerator.vala"
			break;
#line 378 "accelerator.c"
		}
#line 113 "../src/accelerator.vala"
		if (chr == '<') {
#line 114 "../src/accelerator.vala"
			start = pos + 1;
#line 115 "../src/accelerator.vala"
			is_modifier = TRUE;
#line 386 "accelerator.c"
		} else {
			gboolean _tmp1_ = FALSE;
#line 117 "../src/accelerator.vala"
			if (chr == '>') {
#line 117 "../src/accelerator.vala"
				_tmp1_ = is_modifier;
#line 393 "accelerator.c"
			} else {
#line 117 "../src/accelerator.vala"
				_tmp1_ = FALSE;
#line 397 "accelerator.c"
			}
#line 117 "../src/accelerator.vala"
			if (_tmp1_) {
#line 401 "accelerator.c"
				gchar* modifier = NULL;
				gchar* _tmp2_;
				gboolean _tmp3_ = FALSE;
				const gchar* _tmp4_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
				const gchar* _tmp8_;
#line 119 "../src/accelerator.vala"
				_tmp2_ = string_slice (name, (glong) start, (glong) pos);
#line 119 "../src/accelerator.vala"
				modifier = _tmp2_;
#line 121 "../src/accelerator.vala"
				_tmp4_ = modifier;
#line 121 "../src/accelerator.vala"
				if (g_strcmp0 (_tmp4_, "Ctrl") == 0) {
#line 121 "../src/accelerator.vala"
					_tmp3_ = TRUE;
#line 419 "accelerator.c"
				} else {
					const gchar* _tmp5_;
#line 121 "../src/accelerator.vala"
					_tmp5_ = modifier;
#line 121 "../src/accelerator.vala"
					_tmp3_ = g_strcmp0 (_tmp5_, "Control") == 0;
#line 426 "accelerator.c"
				}
#line 121 "../src/accelerator.vala"
				if (_tmp3_) {
#line 122 "../src/accelerator.vala"
					_vala_modifiers = _vala_modifiers | GDK_CONTROL_MASK;
#line 432 "accelerator.c"
				}
#line 125 "../src/accelerator.vala"
				_tmp6_ = modifier;
#line 125 "../src/accelerator.vala"
				if (g_strcmp0 (_tmp6_, "Alt") == 0) {
#line 126 "../src/accelerator.vala"
					_vala_modifiers = _vala_modifiers | GDK_MOD1_MASK;
#line 440 "accelerator.c"
				}
#line 129 "../src/accelerator.vala"
				_tmp7_ = modifier;
#line 129 "../src/accelerator.vala"
				if (g_strcmp0 (_tmp7_, "Shift") == 0) {
#line 130 "../src/accelerator.vala"
					_vala_modifiers = _vala_modifiers | GDK_SHIFT_MASK;
#line 448 "accelerator.c"
				}
#line 133 "../src/accelerator.vala"
				_tmp8_ = modifier;
#line 133 "../src/accelerator.vala"
				if (g_strcmp0 (_tmp8_, "Super") == 0) {
#line 134 "../src/accelerator.vala"
					_vala_modifiers = _vala_modifiers | GDK_SUPER_MASK;
#line 456 "accelerator.c"
				}
#line 137 "../src/accelerator.vala"
				is_modifier = FALSE;
#line 138 "../src/accelerator.vala"
				start = pos + 1;
#line 117 "../src/accelerator.vala"
				_g_free0 (modifier);
#line 464 "accelerator.c"
			}
		}
#line 141 "../src/accelerator.vala"
		_tmp9_ = pos;
#line 141 "../src/accelerator.vala"
		pos = _tmp9_ + 1;
#line 471 "accelerator.c"
	}
#line 144 "../src/accelerator.vala"
	_tmp10_ = string_slice (name, (glong) start, (glong) pos);
#line 144 "../src/accelerator.vala"
	_tmp11_ = _tmp10_;
#line 144 "../src/accelerator.vala"
	_vala_keyval = gdk_keyval_from_name (_tmp11_);
#line 144 "../src/accelerator.vala"
	_g_free0 (_tmp11_);
#line 95 "../src/accelerator.vala"
	if (keyval) {
#line 95 "../src/accelerator.vala"
		*keyval = _vala_keyval;
#line 485 "accelerator.c"
	}
#line 95 "../src/accelerator.vala"
	if (modifiers) {
#line 95 "../src/accelerator.vala"
		*modifiers = _vala_modifiers;
#line 491 "accelerator.c"
	}
}

void
pomodoro_accelerator_unset (PomodoroAccelerator* self)
{
#line 147 "../src/accelerator.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/accelerator.vala"
	pomodoro_accelerator_set_key (self, (guint) 0);
#line 150 "../src/accelerator.vala"
	pomodoro_accelerator_set_modifiers (self, 0);
#line 152 "../src/accelerator.vala"
	g_signal_emit (self, pomodoro_accelerator_signals[POMODORO_ACCELERATOR_CHANGED_SIGNAL], 0);
#line 506 "accelerator.c"
}

static void
pomodoro_accelerator_normalize (guint* keyval,
                                GdkModifierType* modifiers)
{
	GdkModifierType keyval_modifier = 0U;
#line 158 "../src/accelerator.vala"
	keyval_modifier = 0;
#line 160 "../src/accelerator.vala"
	switch (*keyval) {
#line 160 "../src/accelerator.vala"
		case GDK_KEY_Control_L:
#line 160 "../src/accelerator.vala"
		case GDK_KEY_Control_R:
#line 522 "accelerator.c"
		{
#line 164 "../src/accelerator.vala"
			keyval_modifier = GDK_CONTROL_MASK;
#line 165 "../src/accelerator.vala"
			break;
#line 528 "accelerator.c"
		}
#line 160 "../src/accelerator.vala"
		case GDK_KEY_Shift_L:
#line 160 "../src/accelerator.vala"
		case GDK_KEY_Shift_R:
#line 534 "accelerator.c"
		{
#line 169 "../src/accelerator.vala"
			keyval_modifier = GDK_SHIFT_MASK;
#line 170 "../src/accelerator.vala"
			break;
#line 540 "accelerator.c"
		}
#line 160 "../src/accelerator.vala"
		case GDK_KEY_Super_L:
#line 160 "../src/accelerator.vala"
		case GDK_KEY_Super_R:
#line 546 "accelerator.c"
		{
#line 174 "../src/accelerator.vala"
			keyval_modifier = GDK_SUPER_MASK;
#line 175 "../src/accelerator.vala"
			break;
#line 552 "accelerator.c"
		}
#line 160 "../src/accelerator.vala"
		case GDK_KEY_Alt_L:
#line 160 "../src/accelerator.vala"
		case GDK_KEY_Alt_R:
#line 558 "accelerator.c"
		{
#line 179 "../src/accelerator.vala"
			keyval_modifier = GDK_MOD1_MASK;
#line 180 "../src/accelerator.vala"
			break;
#line 564 "accelerator.c"
		}
		default:
#line 160 "../src/accelerator.vala"
		break;
#line 569 "accelerator.c"
	}
#line 183 "../src/accelerator.vala"
	if (keyval_modifier != 0) {
#line 184 "../src/accelerator.vala"
		*keyval = (guint) 0;
#line 185 "../src/accelerator.vala"
		*modifiers = (*modifiers) | keyval_modifier;
#line 577 "accelerator.c"
	}
#line 188 "../src/accelerator.vala"
	*modifiers = (*modifiers) & (((GDK_CONTROL_MASK | GDK_SHIFT_MASK) | GDK_SUPER_MASK) | GDK_MOD1_MASK);
#line 581 "accelerator.c"
}

void
pomodoro_accelerator_set_keyval (PomodoroAccelerator* self,
                                 guint keyval,
                                 GdkModifierType modifiers)
{
	gboolean _tmp0_ = FALSE;
	guint _tmp1_;
#line 194 "../src/accelerator.vala"
	g_return_if_fail (self != NULL);
#line 197 "../src/accelerator.vala"
	pomodoro_accelerator_normalize (&keyval, &modifiers);
#line 200 "../src/accelerator.vala"
	_tmp1_ = self->priv->_key;
#line 200 "../src/accelerator.vala"
	if (_tmp1_ != keyval) {
#line 200 "../src/accelerator.vala"
		_tmp0_ = TRUE;
#line 601 "accelerator.c"
	} else {
		GdkModifierType _tmp2_;
#line 200 "../src/accelerator.vala"
		_tmp2_ = self->priv->_modifiers;
#line 200 "../src/accelerator.vala"
		_tmp0_ = _tmp2_ != modifiers;
#line 608 "accelerator.c"
	}
#line 200 "../src/accelerator.vala"
	if (_tmp0_) {
#line 202 "../src/accelerator.vala"
		pomodoro_accelerator_set_key (self, keyval);
#line 203 "../src/accelerator.vala"
		pomodoro_accelerator_set_modifiers (self, modifiers);
#line 205 "../src/accelerator.vala"
		g_signal_emit (self, pomodoro_accelerator_signals[POMODORO_ACCELERATOR_CHANGED_SIGNAL], 0);
#line 618 "accelerator.c"
	}
}

void
pomodoro_accelerator_validate (PomodoroAccelerator* self,
                               GError** error)
{
	guint key = 0U;
	guint _tmp0_;
	GdkModifierType modifiers = 0U;
	GdkModifierType _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp8_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 209 "../src/accelerator.vala"
	g_return_if_fail (self != NULL);
#line 211 "../src/accelerator.vala"
	_tmp0_ = self->priv->_key;
#line 211 "../src/accelerator.vala"
	key = _tmp0_;
#line 212 "../src/accelerator.vala"
	_tmp1_ = self->priv->_modifiers;
#line 212 "../src/accelerator.vala"
	modifiers = _tmp1_;
#line 214 "../src/accelerator.vala"
	if (key == ((guint) 0)) {
#line 214 "../src/accelerator.vala"
		_tmp2_ = modifiers == 0;
#line 648 "accelerator.c"
	} else {
#line 214 "../src/accelerator.vala"
		_tmp2_ = FALSE;
#line 652 "accelerator.c"
	}
#line 214 "../src/accelerator.vala"
	if (_tmp2_) {
#line 216 "../src/accelerator.vala"
		return;
#line 658 "accelerator.c"
	}
#line 219 "../src/accelerator.vala"
	if (!gtk_accelerator_valid (key, modifiers)) {
#line 662 "accelerator.c"
		GError* _tmp3_;
#line 221 "../src/accelerator.vala"
		_tmp3_ = g_error_new_literal (POMODORO_ACCELERATOR_ERROR, POMODORO_ACCELERATOR_ERROR_INVALID, "Invalid");
#line 221 "../src/accelerator.vala"
		_inner_error0_ = _tmp3_;
#line 221 "../src/accelerator.vala"
		if (_inner_error0_->domain == POMODORO_ACCELERATOR_ERROR) {
#line 221 "../src/accelerator.vala"
			g_propagate_error (error, _inner_error0_);
#line 221 "../src/accelerator.vala"
			return;
#line 674 "accelerator.c"
		} else {
#line 221 "../src/accelerator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 221 "../src/accelerator.vala"
			g_clear_error (&_inner_error0_);
#line 221 "../src/accelerator.vala"
			return;
#line 682 "accelerator.c"
		}
	}
#line 224 "../src/accelerator.vala"
	if (key != ((guint) 0)) {
#line 224 "../src/accelerator.vala"
		_tmp4_ = modifiers == 0;
#line 689 "accelerator.c"
	} else {
#line 224 "../src/accelerator.vala"
		_tmp4_ = FALSE;
#line 693 "accelerator.c"
	}
#line 224 "../src/accelerator.vala"
	if (_tmp4_) {
#line 697 "accelerator.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 226 "../src/accelerator.vala"
		if (key == GDK_KEY_Escape) {
#line 226 "../src/accelerator.vala"
			_tmp6_ = TRUE;
#line 704 "accelerator.c"
		} else {
#line 227 "../src/accelerator.vala"
			_tmp6_ = key == GDK_KEY_BackSpace;
#line 708 "accelerator.c"
		}
#line 226 "../src/accelerator.vala"
		if (_tmp6_) {
#line 226 "../src/accelerator.vala"
			_tmp5_ = TRUE;
#line 714 "accelerator.c"
		} else {
#line 228 "../src/accelerator.vala"
			_tmp5_ = key == GDK_KEY_Return;
#line 718 "accelerator.c"
		}
#line 226 "../src/accelerator.vala"
		if (_tmp5_) {
#line 722 "accelerator.c"
			GError* _tmp7_;
#line 230 "../src/accelerator.vala"
			_tmp7_ = g_error_new_literal (POMODORO_ACCELERATOR_ERROR, POMODORO_ACCELERATOR_ERROR_FORBIDDEN, "Forbidden");
#line 230 "../src/accelerator.vala"
			_inner_error0_ = _tmp7_;
#line 230 "../src/accelerator.vala"
			if (_inner_error0_->domain == POMODORO_ACCELERATOR_ERROR) {
#line 230 "../src/accelerator.vala"
				g_propagate_error (error, _inner_error0_);
#line 230 "../src/accelerator.vala"
				return;
#line 734 "accelerator.c"
			} else {
#line 230 "../src/accelerator.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 230 "../src/accelerator.vala"
				g_clear_error (&_inner_error0_);
#line 230 "../src/accelerator.vala"
				return;
#line 742 "accelerator.c"
			}
		}
	}
#line 235 "../src/accelerator.vala"
	if (key != ((guint) 0)) {
#line 748 "accelerator.c"
		gboolean _tmp9_ = FALSE;
#line 235 "../src/accelerator.vala"
		if (modifiers == 0) {
#line 235 "../src/accelerator.vala"
			_tmp9_ = TRUE;
#line 754 "accelerator.c"
		} else {
#line 235 "../src/accelerator.vala"
			_tmp9_ = modifiers == GDK_SHIFT_MASK;
#line 758 "accelerator.c"
		}
#line 235 "../src/accelerator.vala"
		_tmp8_ = _tmp9_;
#line 762 "accelerator.c"
	} else {
#line 235 "../src/accelerator.vala"
		_tmp8_ = FALSE;
#line 766 "accelerator.c"
	}
#line 235 "../src/accelerator.vala"
	if (_tmp8_) {
#line 770 "accelerator.c"
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
#line 237 "../src/accelerator.vala"
		if (key >= GDK_KEY_a) {
#line 237 "../src/accelerator.vala"
			_tmp20_ = key <= GDK_KEY_z;
#line 786 "accelerator.c"
		} else {
#line 237 "../src/accelerator.vala"
			_tmp20_ = FALSE;
#line 790 "accelerator.c"
		}
#line 237 "../src/accelerator.vala"
		if (_tmp20_) {
#line 237 "../src/accelerator.vala"
			_tmp19_ = TRUE;
#line 796 "accelerator.c"
		} else {
			gboolean _tmp21_ = FALSE;
#line 238 "../src/accelerator.vala"
			if (key >= GDK_KEY_A) {
#line 238 "../src/accelerator.vala"
				_tmp21_ = key <= GDK_KEY_Z;
#line 803 "accelerator.c"
			} else {
#line 238 "../src/accelerator.vala"
				_tmp21_ = FALSE;
#line 807 "accelerator.c"
			}
#line 238 "../src/accelerator.vala"
			_tmp19_ = _tmp21_;
#line 811 "accelerator.c"
		}
#line 237 "../src/accelerator.vala"
		if (_tmp19_) {
#line 237 "../src/accelerator.vala"
			_tmp18_ = TRUE;
#line 817 "accelerator.c"
		} else {
			gboolean _tmp22_ = FALSE;
#line 239 "../src/accelerator.vala"
			if (key >= GDK_KEY_0) {
#line 239 "../src/accelerator.vala"
				_tmp22_ = key <= GDK_KEY_9;
#line 824 "accelerator.c"
			} else {
#line 239 "../src/accelerator.vala"
				_tmp22_ = FALSE;
#line 828 "accelerator.c"
			}
#line 239 "../src/accelerator.vala"
			_tmp18_ = _tmp22_;
#line 832 "accelerator.c"
		}
#line 237 "../src/accelerator.vala"
		if (_tmp18_) {
#line 237 "../src/accelerator.vala"
			_tmp17_ = TRUE;
#line 838 "accelerator.c"
		} else {
			gboolean _tmp23_ = FALSE;
#line 240 "../src/accelerator.vala"
			if (key >= GDK_KEY_kana_fullstop) {
#line 240 "../src/accelerator.vala"
				_tmp23_ = key <= GDK_KEY_semivoicedsound;
#line 845 "accelerator.c"
			} else {
#line 240 "../src/accelerator.vala"
				_tmp23_ = FALSE;
#line 849 "accelerator.c"
			}
#line 240 "../src/accelerator.vala"
			_tmp17_ = _tmp23_;
#line 853 "accelerator.c"
		}
#line 237 "../src/accelerator.vala"
		if (_tmp17_) {
#line 237 "../src/accelerator.vala"
			_tmp16_ = TRUE;
#line 859 "accelerator.c"
		} else {
			gboolean _tmp24_ = FALSE;
#line 241 "../src/accelerator.vala"
			if (key >= GDK_KEY_Arabic_comma) {
#line 241 "../src/accelerator.vala"
				_tmp24_ = key <= GDK_KEY_Arabic_sukun;
#line 866 "accelerator.c"
			} else {
#line 241 "../src/accelerator.vala"
				_tmp24_ = FALSE;
#line 870 "accelerator.c"
			}
#line 241 "../src/accelerator.vala"
			_tmp16_ = _tmp24_;
#line 874 "accelerator.c"
		}
#line 237 "../src/accelerator.vala"
		if (_tmp16_) {
#line 237 "../src/accelerator.vala"
			_tmp15_ = TRUE;
#line 880 "accelerator.c"
		} else {
			gboolean _tmp25_ = FALSE;
#line 242 "../src/accelerator.vala"
			if (key >= GDK_KEY_Serbian_dje) {
#line 242 "../src/accelerator.vala"
				_tmp25_ = key <= GDK_KEY_Cyrillic_HARDSIGN;
#line 887 "accelerator.c"
			} else {
#line 242 "../src/accelerator.vala"
				_tmp25_ = FALSE;
#line 891 "accelerator.c"
			}
#line 242 "../src/accelerator.vala"
			_tmp15_ = _tmp25_;
#line 895 "accelerator.c"
		}
#line 237 "../src/accelerator.vala"
		if (_tmp15_) {
#line 237 "../src/accelerator.vala"
			_tmp14_ = TRUE;
#line 901 "accelerator.c"
		} else {
			gboolean _tmp26_ = FALSE;
#line 243 "../src/accelerator.vala"
			if (key >= GDK_KEY_Greek_ALPHAaccent) {
#line 243 "../src/accelerator.vala"
				_tmp26_ = key <= GDK_KEY_Greek_omega;
#line 908 "accelerator.c"
			} else {
#line 243 "../src/accelerator.vala"
				_tmp26_ = FALSE;
#line 912 "accelerator.c"
			}
#line 243 "../src/accelerator.vala"
			_tmp14_ = _tmp26_;
#line 916 "accelerator.c"
		}
#line 237 "../src/accelerator.vala"
		if (_tmp14_) {
#line 237 "../src/accelerator.vala"
			_tmp13_ = TRUE;
#line 922 "accelerator.c"
		} else {
			gboolean _tmp27_ = FALSE;
#line 244 "../src/accelerator.vala"
			if (key >= GDK_KEY_hebrew_doublelowline) {
#line 244 "../src/accelerator.vala"
				_tmp27_ = key <= GDK_KEY_hebrew_taf;
#line 929 "accelerator.c"
			} else {
#line 244 "../src/accelerator.vala"
				_tmp27_ = FALSE;
#line 933 "accelerator.c"
			}
#line 244 "../src/accelerator.vala"
			_tmp13_ = _tmp27_;
#line 937 "accelerator.c"
		}
#line 237 "../src/accelerator.vala"
		if (_tmp13_) {
#line 237 "../src/accelerator.vala"
			_tmp12_ = TRUE;
#line 943 "accelerator.c"
		} else {
			gboolean _tmp28_ = FALSE;
#line 245 "../src/accelerator.vala"
			if (key >= GDK_KEY_Thai_kokai) {
#line 245 "../src/accelerator.vala"
				_tmp28_ = key <= GDK_KEY_Thai_lekkao;
#line 950 "accelerator.c"
			} else {
#line 245 "../src/accelerator.vala"
				_tmp28_ = FALSE;
#line 954 "accelerator.c"
			}
#line 245 "../src/accelerator.vala"
			_tmp12_ = _tmp28_;
#line 958 "accelerator.c"
		}
#line 237 "../src/accelerator.vala"
		if (_tmp12_) {
#line 237 "../src/accelerator.vala"
			_tmp11_ = TRUE;
#line 964 "accelerator.c"
		} else {
			gboolean _tmp29_ = FALSE;
#line 246 "../src/accelerator.vala"
			if (key >= GDK_KEY_Hangul) {
#line 246 "../src/accelerator.vala"
				_tmp29_ = key <= GDK_KEY_Hangul_Special;
#line 971 "accelerator.c"
			} else {
#line 246 "../src/accelerator.vala"
				_tmp29_ = FALSE;
#line 975 "accelerator.c"
			}
#line 246 "../src/accelerator.vala"
			_tmp11_ = _tmp29_;
#line 979 "accelerator.c"
		}
#line 237 "../src/accelerator.vala"
		if (_tmp11_) {
#line 237 "../src/accelerator.vala"
			_tmp10_ = TRUE;
#line 985 "accelerator.c"
		} else {
			gboolean _tmp30_ = FALSE;
#line 247 "../src/accelerator.vala"
			if (key >= GDK_KEY_Hangul_Kiyeog) {
#line 247 "../src/accelerator.vala"
				_tmp30_ = key <= GDK_KEY_Hangul_J_YeorinHieuh;
#line 992 "accelerator.c"
			} else {
#line 247 "../src/accelerator.vala"
				_tmp30_ = FALSE;
#line 996 "accelerator.c"
			}
#line 247 "../src/accelerator.vala"
			_tmp10_ = _tmp30_;
#line 1000 "accelerator.c"
		}
#line 237 "../src/accelerator.vala"
		if (_tmp10_) {
#line 1004 "accelerator.c"
			GError* _tmp31_;
#line 249 "../src/accelerator.vala"
			_tmp31_ = g_error_new_literal (POMODORO_ACCELERATOR_ERROR, POMODORO_ACCELERATOR_ERROR_TYPING_COLLISION, "Typing collision");
#line 249 "../src/accelerator.vala"
			_inner_error0_ = _tmp31_;
#line 249 "../src/accelerator.vala"
			if (_inner_error0_->domain == POMODORO_ACCELERATOR_ERROR) {
#line 249 "../src/accelerator.vala"
				g_propagate_error (error, _inner_error0_);
#line 249 "../src/accelerator.vala"
				return;
#line 1016 "accelerator.c"
			} else {
#line 249 "../src/accelerator.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 249 "../src/accelerator.vala"
				g_clear_error (&_inner_error0_);
#line 249 "../src/accelerator.vala"
				return;
#line 1024 "accelerator.c"
			}
		}
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 259 "../src/accelerator.vala"
	if ((*length) == (*size)) {
#line 259 "../src/accelerator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 259 "../src/accelerator.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1042 "accelerator.c"
	}
#line 259 "../src/accelerator.vala"
	(*array)[(*length)++] = value;
#line 259 "../src/accelerator.vala"
	(*array)[*length] = NULL;
#line 1048 "accelerator.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 263 "../src/accelerator.vala"
	if ((*length) == (*size)) {
#line 263 "../src/accelerator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 263 "../src/accelerator.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1063 "accelerator.c"
	}
#line 263 "../src/accelerator.vala"
	(*array)[(*length)++] = value;
#line 263 "../src/accelerator.vala"
	(*array)[*length] = NULL;
#line 1069 "accelerator.c"
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 267 "../src/accelerator.vala"
	if ((*length) == (*size)) {
#line 267 "../src/accelerator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 267 "../src/accelerator.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1084 "accelerator.c"
	}
#line 267 "../src/accelerator.vala"
	(*array)[(*length)++] = value;
#line 267 "../src/accelerator.vala"
	(*array)[*length] = NULL;
#line 1090 "accelerator.c"
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 271 "../src/accelerator.vala"
	if ((*length) == (*size)) {
#line 271 "../src/accelerator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 271 "../src/accelerator.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1105 "accelerator.c"
	}
#line 271 "../src/accelerator.vala"
	(*array)[(*length)++] = value;
#line 271 "../src/accelerator.vala"
	(*array)[*length] = NULL;
#line 1111 "accelerator.c"
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 279 "../src/accelerator.vala"
	if ((*length) == (*size)) {
#line 279 "../src/accelerator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 279 "../src/accelerator.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1126 "accelerator.c"
	}
#line 279 "../src/accelerator.vala"
	(*array)[(*length)++] = value;
#line 279 "../src/accelerator.vala"
	(*array)[*length] = NULL;
#line 1132 "accelerator.c"
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1079 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1079 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1080 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1081 "glib-2.0.vapi"
	result = str;
#line 1081 "glib-2.0.vapi"
	return result;
#line 1151 "accelerator.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1173 "accelerator.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1177 "accelerator.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1183 "accelerator.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1187 "accelerator.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1191 "accelerator.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 1199 "accelerator.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1227 "accelerator.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 1236 "accelerator.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1250 "accelerator.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 1259 "accelerator.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 1273 "accelerator.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1282 "accelerator.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 1291 "accelerator.c"
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 284 "../src/accelerator.vala"
	if ((*length) == (*size)) {
#line 284 "../src/accelerator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 284 "../src/accelerator.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1306 "accelerator.c"
	}
#line 284 "../src/accelerator.vala"
	(*array)[(*length)++] = value;
#line 284 "../src/accelerator.vala"
	(*array)[*length] = NULL;
#line 1312 "accelerator.c"
}

static gchar**
pomodoro_accelerator_get_keys_internal (PomodoroAccelerator* self,
                                        gboolean escape,
                                        gint* result_length1)
{
	gchar** elements = NULL;
	gchar** _tmp0_;
	gint elements_length1;
	gint _elements_size_;
	GdkModifierType _tmp1_;
	GdkModifierType _tmp4_;
	GdkModifierType _tmp7_;
	GdkModifierType _tmp10_;
	guint _tmp13_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gchar** result;
#line 254 "../src/accelerator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 256 "../src/accelerator.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 256 "../src/accelerator.vala"
	elements = _tmp0_;
#line 256 "../src/accelerator.vala"
	elements_length1 = 0;
#line 256 "../src/accelerator.vala"
	_elements_size_ = elements_length1;
#line 258 "../src/accelerator.vala"
	_tmp1_ = self->priv->_modifiers;
#line 258 "../src/accelerator.vala"
	if ((_tmp1_ & GDK_SHIFT_MASK) == GDK_SHIFT_MASK) {
#line 1346 "accelerator.c"
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
#line 259 "../src/accelerator.vala"
		if (escape) {
#line 259 "../src/accelerator.vala"
			_tmp2_ = "<Shift>";
#line 1353 "accelerator.c"
		} else {
#line 259 "../src/accelerator.vala"
			_tmp2_ = "Shift";
#line 1357 "accelerator.c"
		}
#line 259 "../src/accelerator.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 259 "../src/accelerator.vala"
		_vala_array_add1 (&elements, &elements_length1, &_elements_size_, _tmp3_);
#line 1363 "accelerator.c"
	}
#line 262 "../src/accelerator.vala"
	_tmp4_ = self->priv->_modifiers;
#line 262 "../src/accelerator.vala"
	if ((_tmp4_ & GDK_SUPER_MASK) == GDK_SUPER_MASK) {
#line 1369 "accelerator.c"
		const gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
#line 263 "../src/accelerator.vala"
		if (escape) {
#line 263 "../src/accelerator.vala"
			_tmp5_ = "<Super>";
#line 1376 "accelerator.c"
		} else {
#line 263 "../src/accelerator.vala"
			_tmp5_ = "Super";
#line 1380 "accelerator.c"
		}
#line 263 "../src/accelerator.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 263 "../src/accelerator.vala"
		_vala_array_add2 (&elements, &elements_length1, &_elements_size_, _tmp6_);
#line 1386 "accelerator.c"
	}
#line 266 "../src/accelerator.vala"
	_tmp7_ = self->priv->_modifiers;
#line 266 "../src/accelerator.vala"
	if ((_tmp7_ & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
#line 1392 "accelerator.c"
		const gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
#line 267 "../src/accelerator.vala"
		if (escape) {
#line 267 "../src/accelerator.vala"
			_tmp8_ = "<Ctrl>";
#line 1399 "accelerator.c"
		} else {
#line 267 "../src/accelerator.vala"
			_tmp8_ = "Ctrl";
#line 1403 "accelerator.c"
		}
#line 267 "../src/accelerator.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 267 "../src/accelerator.vala"
		_vala_array_add3 (&elements, &elements_length1, &_elements_size_, _tmp9_);
#line 1409 "accelerator.c"
	}
#line 270 "../src/accelerator.vala"
	_tmp10_ = self->priv->_modifiers;
#line 270 "../src/accelerator.vala"
	if ((_tmp10_ & GDK_MOD1_MASK) == GDK_MOD1_MASK) {
#line 1415 "accelerator.c"
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_;
#line 271 "../src/accelerator.vala"
		if (escape) {
#line 271 "../src/accelerator.vala"
			_tmp11_ = "<Alt>";
#line 1422 "accelerator.c"
		} else {
#line 271 "../src/accelerator.vala"
			_tmp11_ = "Alt";
#line 1426 "accelerator.c"
		}
#line 271 "../src/accelerator.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 271 "../src/accelerator.vala"
		_vala_array_add4 (&elements, &elements_length1, &_elements_size_, _tmp12_);
#line 1432 "accelerator.c"
	}
#line 274 "../src/accelerator.vala"
	_tmp13_ = self->priv->_key;
#line 274 "../src/accelerator.vala"
	if (_tmp13_ != ((guint) 0)) {
#line 1438 "accelerator.c"
		guint keyval = 0U;
		guint _tmp14_;
		gchar* name = NULL;
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 275 "../src/accelerator.vala"
		_tmp14_ = self->priv->_key;
#line 275 "../src/accelerator.vala"
		keyval = gdk_keyval_to_upper (_tmp14_);
#line 276 "../src/accelerator.vala"
		_tmp15_ = gdk_keyval_name (keyval);
#line 276 "../src/accelerator.vala"
		_tmp16_ = g_strdup (_tmp15_);
#line 276 "../src/accelerator.vala"
		name = _tmp16_;
#line 278 "../src/accelerator.vala"
		if (escape) {
#line 1456 "accelerator.c"
			const gchar* _tmp17_;
			gchar* _tmp18_;
#line 279 "../src/accelerator.vala"
			_tmp17_ = name;
#line 279 "../src/accelerator.vala"
			_tmp18_ = g_strdup (_tmp17_);
#line 279 "../src/accelerator.vala"
			_vala_array_add5 (&elements, &elements_length1, &_elements_size_, _tmp18_);
#line 1465 "accelerator.c"
		} else {
			gunichar key = 0U;
			gchar* _tmp19_ = NULL;
			gchar* _tmp23_;
#line 282 "../src/accelerator.vala"
			key = (gunichar) gdk_keyval_to_unicode (keyval);
#line 284 "../src/accelerator.vala"
			if (key > ((gunichar) 0)) {
#line 1474 "accelerator.c"
				gchar* _tmp20_;
#line 284 "../src/accelerator.vala"
				_tmp20_ = g_unichar_to_string (key);
#line 284 "../src/accelerator.vala"
				_g_free0 (_tmp19_);
#line 284 "../src/accelerator.vala"
				_tmp19_ = _tmp20_;
#line 1482 "accelerator.c"
			} else {
				const gchar* _tmp21_;
				gchar* _tmp22_;
#line 284 "../src/accelerator.vala"
				_tmp21_ = name;
#line 284 "../src/accelerator.vala"
				_tmp22_ = string_replace (_tmp21_, "_", " ");
#line 284 "../src/accelerator.vala"
				_g_free0 (_tmp19_);
#line 284 "../src/accelerator.vala"
				_tmp19_ = _tmp22_;
#line 1494 "accelerator.c"
			}
#line 284 "../src/accelerator.vala"
			_tmp23_ = g_strdup (_tmp19_);
#line 284 "../src/accelerator.vala"
			_vala_array_add6 (&elements, &elements_length1, &_elements_size_, _tmp23_);
#line 278 "../src/accelerator.vala"
			_g_free0 (_tmp19_);
#line 1502 "accelerator.c"
		}
#line 274 "../src/accelerator.vala"
		_g_free0 (name);
#line 1506 "accelerator.c"
	}
#line 288 "../src/accelerator.vala"
	_tmp24_ = elements;
#line 288 "../src/accelerator.vala"
	_tmp24__length1 = elements_length1;
#line 288 "../src/accelerator.vala"
	if (result_length1) {
#line 288 "../src/accelerator.vala"
		*result_length1 = _tmp24__length1;
#line 1516 "accelerator.c"
	}
#line 288 "../src/accelerator.vala"
	result = _tmp24_;
#line 288 "../src/accelerator.vala"
	return result;
#line 1522 "accelerator.c"
}

gchar**
pomodoro_accelerator_get_keys (PomodoroAccelerator* self,
                               gint* result_length1)
{
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** result;
#line 291 "../src/accelerator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 293 "../src/accelerator.vala"
	_tmp1_ = pomodoro_accelerator_get_keys_internal (self, FALSE, &_tmp0_);
#line 293 "../src/accelerator.vala"
	_tmp2_ = _tmp1_;
#line 293 "../src/accelerator.vala"
	_tmp2__length1 = _tmp0_;
#line 293 "../src/accelerator.vala"
	if (result_length1) {
#line 293 "../src/accelerator.vala"
		*result_length1 = _tmp2__length1;
#line 1546 "accelerator.c"
	}
#line 293 "../src/accelerator.vala"
	result = _tmp2_;
#line 293 "../src/accelerator.vala"
	return result;
#line 1552 "accelerator.c"
}

PomodoroAccelerator*
pomodoro_accelerator_construct (GType object_type)
{
	PomodoroAccelerator * self = NULL;
#line 45 "../src/accelerator.vala"
	self = (PomodoroAccelerator*) g_object_new (object_type, NULL);
#line 45 "../src/accelerator.vala"
	return self;
#line 1563 "accelerator.c"
}

PomodoroAccelerator*
pomodoro_accelerator_new (void)
{
#line 45 "../src/accelerator.vala"
	return pomodoro_accelerator_construct (POMODORO_TYPE_ACCELERATOR);
#line 1571 "accelerator.c"
}

static guint
pomodoro_accelerator_get_key (PomodoroAccelerator* self)
{
	guint result;
#line 47 "../src/accelerator.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 47 "../src/accelerator.vala"
	result = self->priv->_key;
#line 47 "../src/accelerator.vala"
	return result;
#line 1584 "accelerator.c"
}

static void
pomodoro_accelerator_set_key (PomodoroAccelerator* self,
                              guint value)
{
#line 47 "../src/accelerator.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/accelerator.vala"
	self->priv->_key = value;
#line 1595 "accelerator.c"
}

static GdkModifierType
pomodoro_accelerator_get_modifiers (PomodoroAccelerator* self)
{
	GdkModifierType result;
#line 48 "../src/accelerator.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 48 "../src/accelerator.vala"
	result = self->priv->_modifiers;
#line 48 "../src/accelerator.vala"
	return result;
#line 1608 "accelerator.c"
}

static void
pomodoro_accelerator_set_modifiers (PomodoroAccelerator* self,
                                    GdkModifierType value)
{
#line 48 "../src/accelerator.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/accelerator.vala"
	self->priv->_modifiers = value;
#line 1619 "accelerator.c"
}

gchar*
pomodoro_accelerator_get_name (PomodoroAccelerator* self)
{
	gchar* result;
	GString* name = NULL;
	GString* _tmp0_;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	GString* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
#line 51 "../src/accelerator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/accelerator.vala"
	_tmp0_ = g_string_new ("");
#line 52 "../src/accelerator.vala"
	name = _tmp0_;
#line 54 "../src/accelerator.vala"
	_tmp2_ = pomodoro_accelerator_get_keys_internal (self, TRUE, &_tmp1_);
#line 1641 "accelerator.c"
	{
		gchar** element_collection = NULL;
		gint element_collection_length1 = 0;
		gint _element_collection_size_ = 0;
		gint element_it = 0;
#line 54 "../src/accelerator.vala"
		element_collection = _tmp2_;
#line 54 "../src/accelerator.vala"
		element_collection_length1 = _tmp1_;
#line 54 "../src/accelerator.vala"
		for (element_it = 0; element_it < element_collection_length1; element_it = element_it + 1) {
#line 1653 "accelerator.c"
			gchar* _tmp3_;
			gchar* element = NULL;
#line 54 "../src/accelerator.vala"
			_tmp3_ = g_strdup (element_collection[element_it]);
#line 54 "../src/accelerator.vala"
			element = _tmp3_;
#line 1660 "accelerator.c"
			{
				GString* _tmp4_;
				const gchar* _tmp5_;
#line 55 "../src/accelerator.vala"
				_tmp4_ = name;
#line 55 "../src/accelerator.vala"
				_tmp5_ = element;
#line 55 "../src/accelerator.vala"
				g_string_append (_tmp4_, _tmp5_);
#line 54 "../src/accelerator.vala"
				_g_free0 (element);
#line 1672 "accelerator.c"
			}
		}
#line 54 "../src/accelerator.vala"
		element_collection = (_vala_array_free (element_collection, element_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1677 "accelerator.c"
	}
#line 58 "../src/accelerator.vala"
	_tmp6_ = name;
#line 58 "../src/accelerator.vala"
	_tmp7_ = _tmp6_->str;
#line 58 "../src/accelerator.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 58 "../src/accelerator.vala"
	result = _tmp8_;
#line 58 "../src/accelerator.vala"
	_g_string_free0 (name);
#line 58 "../src/accelerator.vala"
	return result;
#line 1691 "accelerator.c"
}

void
pomodoro_accelerator_set_name (PomodoroAccelerator* self,
                               const gchar* value)
{
	guint keyval = 0U;
	GdkModifierType modifiers = 0U;
	guint _tmp0_ = 0U;
	GdkModifierType _tmp1_ = 0U;
#line 60 "../src/accelerator.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/accelerator.vala"
	keyval = (guint) 0;
#line 62 "../src/accelerator.vala"
	modifiers = 0;
#line 64 "../src/accelerator.vala"
	pomodoro_accelerator_parse (value, &_tmp0_, &_tmp1_);
#line 64 "../src/accelerator.vala"
	keyval = _tmp0_;
#line 64 "../src/accelerator.vala"
	modifiers = _tmp1_;
#line 66 "../src/accelerator.vala"
	pomodoro_accelerator_set_keyval (self, keyval, modifiers);
#line 60 "../src/accelerator.vala"
	g_object_notify_by_pspec ((GObject *) self, pomodoro_accelerator_properties[POMODORO_ACCELERATOR_NAME_PROPERTY]);
#line 1718 "accelerator.c"
}

gchar*
pomodoro_accelerator_get_display_name (PomodoroAccelerator* self)
{
	gchar* result;
	GString* name = NULL;
	GString* _tmp0_;
	gboolean is_first = FALSE;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	GString* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
#line 71 "../src/accelerator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../src/accelerator.vala"
	_tmp0_ = g_string_new ("");
#line 72 "../src/accelerator.vala"
	name = _tmp0_;
#line 73 "../src/accelerator.vala"
	is_first = TRUE;
#line 75 "../src/accelerator.vala"
	_tmp2_ = pomodoro_accelerator_get_keys_internal (self, FALSE, &_tmp1_);
#line 1743 "accelerator.c"
	{
		gchar** element_collection = NULL;
		gint element_collection_length1 = 0;
		gint _element_collection_size_ = 0;
		gint element_it = 0;
#line 75 "../src/accelerator.vala"
		element_collection = _tmp2_;
#line 75 "../src/accelerator.vala"
		element_collection_length1 = _tmp1_;
#line 75 "../src/accelerator.vala"
		for (element_it = 0; element_it < element_collection_length1; element_it = element_it + 1) {
#line 1755 "accelerator.c"
			gchar* _tmp3_;
			gchar* element = NULL;
#line 75 "../src/accelerator.vala"
			_tmp3_ = g_strdup (element_collection[element_it]);
#line 75 "../src/accelerator.vala"
			element = _tmp3_;
#line 1762 "accelerator.c"
			{
				GString* _tmp5_;
				const gchar* _tmp6_;
#line 77 "../src/accelerator.vala"
				if (is_first) {
#line 78 "../src/accelerator.vala"
					is_first = FALSE;
#line 1770 "accelerator.c"
				} else {
					GString* _tmp4_;
#line 80 "../src/accelerator.vala"
					_tmp4_ = name;
#line 80 "../src/accelerator.vala"
					g_string_append (_tmp4_, " + ");
#line 1777 "accelerator.c"
				}
#line 83 "../src/accelerator.vala"
				_tmp5_ = name;
#line 83 "../src/accelerator.vala"
				_tmp6_ = element;
#line 83 "../src/accelerator.vala"
				g_string_append (_tmp5_, _tmp6_);
#line 75 "../src/accelerator.vala"
				_g_free0 (element);
#line 1787 "accelerator.c"
			}
		}
#line 75 "../src/accelerator.vala"
		element_collection = (_vala_array_free (element_collection, element_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1792 "accelerator.c"
	}
#line 86 "../src/accelerator.vala"
	_tmp7_ = name;
#line 86 "../src/accelerator.vala"
	_tmp8_ = _tmp7_->str;
#line 86 "../src/accelerator.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 86 "../src/accelerator.vala"
	result = _tmp9_;
#line 86 "../src/accelerator.vala"
	_g_string_free0 (name);
#line 86 "../src/accelerator.vala"
	return result;
#line 1806 "accelerator.c"
}

static void
pomodoro_accelerator_real_changed (PomodoroAccelerator* self)
{
#line 298 "../src/accelerator.vala"
	g_object_notify ((GObject*) self, "name");
#line 299 "../src/accelerator.vala"
	g_object_notify ((GObject*) self, "display-name");
#line 1816 "accelerator.c"
}

static void
pomodoro_accelerator_class_init (PomodoroAcceleratorClass * klass,
                                 gpointer klass_data)
{
#line 45 "../src/accelerator.vala"
	pomodoro_accelerator_parent_class = g_type_class_peek_parent (klass);
#line 45 "../src/accelerator.vala"
	g_type_class_adjust_private_offset (klass, &PomodoroAccelerator_private_offset);
#line 45 "../src/accelerator.vala"
	((PomodoroAcceleratorClass *) klass)->changed = pomodoro_accelerator_real_changed;
#line 45 "../src/accelerator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_accelerator_get_property;
#line 45 "../src/accelerator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_accelerator_set_property;
#line 45 "../src/accelerator.vala"
	G_OBJECT_CLASS (klass)->finalize = pomodoro_accelerator_finalize;
#line 45 "../src/accelerator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_ACCELERATOR_NAME_PROPERTY, pomodoro_accelerator_properties[POMODORO_ACCELERATOR_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 45 "../src/accelerator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_ACCELERATOR_DISPLAY_NAME_PROPERTY, pomodoro_accelerator_properties[POMODORO_ACCELERATOR_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 45 "../src/accelerator.vala"
	pomodoro_accelerator_signals[POMODORO_ACCELERATOR_CHANGED_SIGNAL] = g_signal_new ("changed", POMODORO_TYPE_ACCELERATOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PomodoroAcceleratorClass, changed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1841 "accelerator.c"
}

static void
pomodoro_accelerator_instance_init (PomodoroAccelerator * self,
                                    gpointer klass)
{
#line 45 "../src/accelerator.vala"
	self->priv = pomodoro_accelerator_get_instance_private (self);
#line 1850 "accelerator.c"
}

static void
pomodoro_accelerator_finalize (GObject * obj)
{
	PomodoroAccelerator * self;
#line 45 "../src/accelerator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_ACCELERATOR, PomodoroAccelerator);
#line 45 "../src/accelerator.vala"
	G_OBJECT_CLASS (pomodoro_accelerator_parent_class)->finalize (obj);
#line 1861 "accelerator.c"
}

static GType
pomodoro_accelerator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroAcceleratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_accelerator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroAccelerator), 0, (GInstanceInitFunc) pomodoro_accelerator_instance_init, NULL };
	GType pomodoro_accelerator_type_id;
	pomodoro_accelerator_type_id = g_type_register_static (G_TYPE_OBJECT, "PomodoroAccelerator", &g_define_type_info, 0);
	PomodoroAccelerator_private_offset = g_type_add_instance_private (pomodoro_accelerator_type_id, sizeof (PomodoroAcceleratorPrivate));
	return pomodoro_accelerator_type_id;
}

GType
pomodoro_accelerator_get_type (void)
{
	static volatile gsize pomodoro_accelerator_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_accelerator_type_id__once)) {
		GType pomodoro_accelerator_type_id;
		pomodoro_accelerator_type_id = pomodoro_accelerator_get_type_once ();
		g_once_init_leave (&pomodoro_accelerator_type_id__once, pomodoro_accelerator_type_id);
	}
	return pomodoro_accelerator_type_id__once;
}

static void
_vala_pomodoro_accelerator_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	PomodoroAccelerator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_ACCELERATOR, PomodoroAccelerator);
#line 45 "../src/accelerator.vala"
	switch (property_id) {
#line 45 "../src/accelerator.vala"
		case POMODORO_ACCELERATOR_NAME_PROPERTY:
#line 45 "../src/accelerator.vala"
		g_value_take_string (value, pomodoro_accelerator_get_name (self));
#line 45 "../src/accelerator.vala"
		break;
#line 45 "../src/accelerator.vala"
		case POMODORO_ACCELERATOR_DISPLAY_NAME_PROPERTY:
#line 45 "../src/accelerator.vala"
		g_value_take_string (value, pomodoro_accelerator_get_display_name (self));
#line 45 "../src/accelerator.vala"
		break;
#line 1908 "accelerator.c"
		default:
#line 45 "../src/accelerator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 45 "../src/accelerator.vala"
		break;
#line 1914 "accelerator.c"
	}
}

static void
_vala_pomodoro_accelerator_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	PomodoroAccelerator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_ACCELERATOR, PomodoroAccelerator);
#line 45 "../src/accelerator.vala"
	switch (property_id) {
#line 45 "../src/accelerator.vala"
		case POMODORO_ACCELERATOR_NAME_PROPERTY:
#line 45 "../src/accelerator.vala"
		pomodoro_accelerator_set_name (self, g_value_get_string (value));
#line 45 "../src/accelerator.vala"
		break;
#line 1934 "accelerator.c"
		default:
#line 45 "../src/accelerator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 45 "../src/accelerator.vala"
		break;
#line 1940 "accelerator.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

